require 'net/http'
require 'uri'
require 'json'

module Pavlok
  class Web
    HOST = "https://app.pavlok.com"
    API_PATH = "api/v1"

    def self.call(stimulus, token)
      attempt = self.new(stimulus, token)
      attempt.call
    end
    
    def initialize(stimulus, token)
      @stimulus, @token = stimulus, token
    end

    def call
      response = post
    end
    
    def post
      puts url
      client.post(url, data, headers)
    end
    
    def client
      @client = Net::HTTP
    end
    
    def url
      URI([host, path].join("/"))
    end
    
    def host
      HOST
    end
    
    def path
      [API_PATH, @stimulus.kind, @stimulus.value].join("/")
    end
    
    def data
      @stimulus.data.to_json
    end
    
    def headers
      {
        "Content-Type" => "application/json",
        "Authorization" => "Bearer #{@token}"
      }
    end
    
    
  end
end
